<template>
    <div>
        <q-expansion-item
            v-if="conversationTransferList.length > 0"
            expand-icon-class="expension-icon"
            header-class="expension-item-ongoing helvetica-neue-medium font-18"
            class="q-mb-md task-request"
            expand-icon="img:icons\open.png"
            expanded-icon="img:icons\close.png"
            :label="$t('home.taskRequest')"
        >
            <q-card
                class="card-item-ongoing"
                v-for="conversationTransfer in conversationTransferList"
                :key="conversationTransfer.id"
            >
                <q-card-section class="q-pa-none">
                    <div class="scrollable-card">
                        <div class="row q-pa-none justify-center">
                            <div class="single-card q-mt-xs q-mb-xs col-11">
                                <div
                                    class="
                                        card-items
                                        helvetica-neue-medium
                                        font-18
                                        items-center
                                        row
                                        justify-start
                                    "
                                >
                                    <!-- Details -->
                                    <div
                                        class="
                                            col-8
                                            justify-start
                                            items-center
                                            q-pa-md
                                        "
                                    >
                                        <span
                                            v-if="
                                                conversationTransfer.type ==
                                                ConversationTransferListType.TRANSFER
                                            "
                                            class="
                                                helvetica-neue-medium
                                                font-18
                                                items-center
                                                q-pb-xs
                                            "
                                        >
                                            {{
                                                conversationTransfer?.user.name
                                            }}
                                            wants to transfer the task to you
                                        </span>

                                        <span
                                            v-if="
                                                conversationTransfer.type ==
                                                ConversationTransferListType.REQUEST
                                            "
                                            class="
                                                helvetica-neue-medium
                                                font-18
                                                items-center
                                                q-pb-xs
                                            "
                                        >
                                            {{
                                                conversationTransfer?.user.name
                                            }}
                                            has requested to get the task
                                        </span>
                                    </div>

                                    <!-- Approve / Reject Button -->
                                    <div class="col-4 items-center text-center">
                                        <div class="row">
                                            <div class="col-6 text-center">
                                                <!-- accept(conversation-id) -->
                                                <q-btn
                                                    text
                                                    @click="
                                                        accept(
                                                            conversationTransfer.id
                                                        )
                                                    "
                                                    no-shadow
                                                    flat
                                                >
                                                    <q-icon
                                                        size="md"
                                                        name="img:icons\accept.png"
                                                    ></q-icon>
                                                </q-btn>
                                            </div>
                                            <div class="col-5 text-center">
                                                <q-btn
                                                    text
                                                    @click="
                                                        reject(
                                                            conversationTransfer.id
                                                        )
                                                    "
                                                    no-shadow
                                                    flat
                                                >
                                                    <!-- reject(conversation-id) -->
                                                    <q-icon
                                                        size="md"
                                                        name="img:icons\reject.png"
                                                    ></q-icon>
                                                </q-btn>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </q-card-section>
            </q-card>
        </q-expansion-item>
        <q-expansion-item
            expand-separator
            expand-icon="img:icons\open.png"
            expanded-icon="img:icons\close.png"
            expand-icon-class="expension-icon"
            header-class="expension-item-ongoing helvetica-neue-medium font-14"
            class="q-mb-sm"
        >
            <template v-slot:header>
                <div class="custom-header">
                    {{ $t('preference.issueFilter') }}
                </div>
            </template>
            <q-card class="card-item-ongoing">
                <q-card-section class="q-pa-none">
                    <q-option-group
                        class="issueType-mobile"
                        :options="state.options"
                        type="checkbox"
                        left-label
                        v-model="state.issues"
                    />
                </q-card-section>
            </q-card>
        </q-expansion-item>
        <div
            class="conversation-card"
            v-for="list in state.filterConvList"
            v-bind:key="list.id"
        >
            <q-card class="card-item-ongoing">
                <q-card-section class="q-pa-none">
                    <div class="scrollable-card">
                        <div class="row q-pa-none justify-center">
                            <div class="single-card q-mt-xs q-mb-xs col-12">
                                <div
                                    class="
                                        card-items
                                        helvetica-neue-medium
                                        font-18
                                        row
                                        justify-start
                                    "
                                    :class="
                                        state.selectedList == list.id
                                            ? 'active'
                                            : ''
                                    "
                                    @click="selectedConversation(list)"
                                >
                                    <!-- New Message Badge -->
                                    <span
                                        class="new-message-badge"
                                        v-if="
                                            Object.values(
                                                newMessageList
                                            ).indexOf(list.id) > -1 &&
                                            activeChat(
                                                list.id,
                                                selectedConversationID
                                            )
                                        "
                                    ></span>
                                    <div class="col-7">
                                        <div
                                            class="
                                                helvetica-neue-normal
                                                font-14
                                                items-center
                                                q-pt-sm q-px-md
                                            "
                                        >
                                            {{ list.user.name }}
                                        </div>

                                        <div class="q-px-sm">
                                            <q-icon
                                                class="label q-ma-xs font-12"
                                                v-for="label in list.labels"
                                                :key="label.id"
                                                :style="{
                                                    backgroundColor: label.color
                                                }"
                                                :name="label.icon"
                                                color="white"
                                                size="xs"
                                            ></q-icon>
                                        </div>
                                    </div>

                                    <!-- Date Time -->
                                    <div
                                        class="
                                            col-5
                                            row
                                            column
                                            items-end
                                            q-pt-sm q-pr-md
                                        "
                                    >
                                        <span
                                            class="
                                                helvetica-neue-normal
                                                font-12
                                                items-center
                                            "
                                        >
                                            {{ formatDate(list.updatedAt) }}
                                        </span>
                                        <span
                                            class="
                                                helvetica-neue-medium
                                                font-12
                                                items-center
                                                q-pt-xs
                                            "
                                        >
                                            {{ formatTime(list.updatedAt) }}
                                        </span>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </q-card-section>
            </q-card>
        </div>
    </div>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-unsafe-call */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
/* eslint-disable @typescript-eslint/no-explicit-any*/
/* eslint-disable @typescript-eslint/no-floating-promises */
/* eslint-disable @typescript-eslint/no-misused-promises */
/* eslint-disable @typescript-eslint/require-await */
import { useStore } from 'src/store';
import {
    defineComponent,
    ref,
    reactive,
    watch,
    onMounted,
    computed
} from 'vue';
import { mapGetters } from 'vuex';
import { BasicResponse } from 'src/services/responses/BasicResponse';
import { ConversationTransferListType } from 'src/services/enums/ConversationTransferListType';
import { useRouter } from 'vue-router';
import moment from 'moment';
import localForage from 'localforage';

export default defineComponent({
    name: 'OngoingIssue',
    computed: {
        ...mapGetters({
            selectedBusinessID: 'business/getBusinessID',
            user: 'user/getUser',
            conversationTransferList:
                'conversation/getConversationsTransferList',
            selectedConversationID: 'conversation/getSelectedConversationID',
            newMessageList: 'message/getNewMessageList',
            newForceConversationList: 'conversation/getForceTransferList',
            ongoingDrawer: 'menu/getOngoingDrawer'
        })
    },
    setup() {
        const store = useStore();
        const router = useRouter();
        const conversationState = computed(() => {
            return store.state.conversation;
        });
        const newMessageStore = localForage.createInstance({
            name: 'lobbi/newMessage'
        });

        const issueTypeStore = localForage.createInstance({
            name: 'lobbi/issueType'
        });

        // computed
        const socketStatus = computed(() => {
            return store.state.conversation.socket;
        });

        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });

        const selectedBranch = computed(() => {
            return store.state.branch.branch;
        });

        const selectedIssueTypeId = computed(() => {
            return store.state.conversation.selectedIssueTypeID;
        });

        const filterConv = computed(() => {
            return store.state.conversation.conversationsList;
        });

        // data
        let search = ref('');
        let state = reactive({
            selectedUser: ref(''),
            conversation: [] as any,
            issuesType: [] as any,
            loadingState: ref(false),
            searchResults: ref(false),
            success: ref(false),
            error: ref(false),
            confirm: ref(false),
            convId: '' as string,
            currentIndex: 0,
            selectedList: '' as string,
            searchList: [] as any,
            searchMessageList: [] as any,
            invitationList: [] as any,
            lengths: 0,
            historyList: [] as any,
            newForceConversationStatus: ref(false),
            newMessageList: [] as any,
            permissions: computed(() => {
                return store.state.role.permissions;
            }),
            issueType: computed(() => {
                return store.state.issueType.issueTypes;
            }),
            options: [] as any,
            issues: [] as any,
            filterConv: computed(() => {
                return store.state.conversation.conversationsList;
            }),
            filterConvList: filterConv as any,
            filteredConversation: [] as any
        });

        // watch
        watch(selectedBusinessId, () => {
            state.options = [];
            state.issues = [];
            state.selectedList = '';
            if (selectedBusinessId.value) {
                clearSelectedIssueType();
                setTimeout(() => {
                    getIssueType();
                }, 500);
            }
        });

        watch(selectedBranch, (currentValue) => {
            if (
                currentValue &&
                store.state.role.permissions.conversation?.list
            ) {
                setTimeout(() => getConversationList(), 500);
            }
        });

        watch(filterConv, () => {
            setTimeout(() => {
                getConversationList();
            }, 500);
        });

        watch(search, async (currentValue) => {
            if (currentValue) {
                state.searchList = [];
                state.searchMessageList = [];
                await searchFunction(currentValue);
            } else {
                state.loadingState = false;
                state.searchResults = false;
            }
        });

        watch(router.currentRoute, (to, from) => {
            // If is from the same tab no need to run this
            // If conversation id is the same no need to run this
            // Only run when there is conversation inside state.ticketConversation
            // Only run when link contain 'chat'

            // OR
            // is from notification
            // Get last notification value
            const index = store.state.notification.list.length - 1;
            let notificationConversationID = '';
            if (store.state.notification.list[index]) {
                notificationConversationID =
                    store.state.notification.list[index]?.conversationId;
            }

            if (
                (from.name != to.name &&
                    to.query.conversationId != from.query.conversationId &&
                    conversationState.value.ticketConversation &&
                    router.currentRoute.value.path.includes('chat', 1)) ||
                (from.name == to.name &&
                    notificationConversationID == to.query.conversationId &&
                    conversationState.value.ticketConversation &&
                    router.currentRoute.value.path.includes('chat', 1))
            ) {
                selectedConversation(
                    conversationState.value.ticketConversation
                );
            }

            state.selectedList =
                store.state.conversation.selectedConversationID ?? '';
        });

        store.watch(
            (state) => state.issueType.issueTypes,
            () => {
                state.issuesType = store.state.issueType.issueTypes;
            }
        );

        watch(
            () => state.issues,
            () => {
                store.dispatch(
                    'conversation/setSelectedIssueTypeID',
                    state.issues
                );
                getConversationList();
            }
        );

        // methods
        const searchFunction = async (search: string) => {
            state.loadingState = true;

            const result: any = await store.dispatch(
                'conversation/searchRelation',
                {
                    keyword: search
                }
            );

            const resultMessage: any = await store.dispatch(
                'message/searchRelation',
                {
                    keyword: search
                }
            );

            if (result.users.length > 0) {
                state.loadingState = false;
                state.searchList = result.users;
            } else {
                state.loadingState = false;
            }

            if (resultMessage.messages.length > 0) {
                state.loadingState = false;
                state.searchMessageList = resultMessage.messages;
            } else {
                state.loadingState = false;
            }
        };

        const getConversationList = () => {
            state.filteredConversation = [];
            state.filterConvList = ref([]);
            state.issues.forEach((element: string) => {
                const newConv =
                    conversationState.value.conversationsList.filter(
                        (conversation) => {
                            if (conversation.issueType.id === element)
                                return conversation;
                        }
                    );
                newConv.forEach((element2: any) => {
                    if (element2.issueType.id == element) {
                        state.filteredConversation.push(element2);
                        state.filterConvList = state.filteredConversation;
                    }
                });
            });
        };

        const formatTime = (updatedAt: Date) => {
            return moment(updatedAt).format('hh:mm A');
        };

        const formatDate = (updatedAt: Date) => {
            return moment.utc(updatedAt).local().format('D/M/Y');
        };

        const selectedConversation = (conversation: {
            id: string;
            user: { id: string };
        }) => {
            getLocalForage();
            state.selectedList = conversation.id;

            store.dispatch(
                'conversation/setSelectedConversationID',
                conversation.id
            );

            store.dispatch(
                'conversation/setSelectedConversation',
                conversation
            );

            store.dispatch(
                'conversation/setSelectedUserID',
                conversation.user.id
            );

            store.dispatch('message/clearNewMessage', conversation.id);

            router.push({
                path: '/chat',
                query: {
                    conversationId: conversation.id,
                    businessId: store.state.business.businessID,
                    branchId: store.state.branch.branch.id
                }
            });

            if (conversation) {
                store.commit('chat/selectConversation', conversation);
            }

            store.dispatch('conversation/unsetComponent', true);

            store.dispatch('menu/setOngoingDrawer', false);
        };

        const clearSelectedUserConversation = () => {
            store.dispatch('conversation/clearSelectedUserID');
        };

        const clearSelectedIssueType = () => {
            store.dispatch('conversation/clearSelectedIssueTypeID');
        };

        const getConversationsTransferList = async () => {
            if (
                (state.permissions?.conversation?.list == true &&
                    state.permissions?.conversation?.transfer == true) ||
                store.getters['business/getBusiness']?.member.isOwner
            ) {
                await store.dispatch(
                    'conversation/getConversationsTransferList',
                    store.state.business.businessID
                );
            }
        };

        const accept = (transferID: string) => {
            if (state.permissions?.conversation?.join == true) {
                const data = {
                    status: 1,
                    transferID: transferID
                };
                setTimeout(async () => {
                    const result: BasicResponse = await store.dispatch(
                        'conversation/responseTransfer',
                        data
                    );

                    if (result.status == 200) {
                        store.dispatch('conversation/getJoinedConversations', {
                            businessID: store.state.business.businessID,
                            agentID: store.state.user?.user?.id,
                            status: 1
                        });
                        store.dispatch(
                            'conversation/clearSelectedConversationID'
                        );
                        store.dispatch('chat/unselectConversation');
                        store.dispatch('message/reset');
                    }
                }, 1000);
            }
        };

        const reject = (transferID: string) => {
            if (state.permissions?.conversation?.join == true) {
                const data = {
                    status: 2,
                    transferID: transferID
                };
                store.dispatch('conversation/responseTransfer', data);
            }
        };

        const resetNewForceConversationNotification = (issueTypeId: string) => {
            store.dispatch(
                'issueType/resetForceTransferNotification',
                issueTypeId
            );
            state.issuesType = store.state.issueType.issueTypes;
        };

        const activeChat = (
            conversationId: string,
            selectedConversationID: string
        ) => {
            if (selectedConversationID == conversationId) {
                store.dispatch('message/clearNewMessage', conversationId);
                return false;
            }
            return true;
        };

        const getLocalForage = () => {
            newMessageStore.getItem(
                'newMessageList',
                function (err, value: any) {
                    if (value) {
                        store.state.message.newMessageList = JSON.parse(value);
                    }
                }
            );

            if (store.state.business.businessID) {
                issueTypeStore.getItem(
                    store.state.business.businessID,
                    function (err, value: any) {
                        if (value) {
                            store.state.issueType.issueTypes =
                                JSON.parse(value);
                            state.issuesType = store.state.issueType.issueTypes;
                        }
                    }
                );
            }
        };

        const checkIfUrlRedirect = async () => {
            const businessId = router.currentRoute.value.query.businessId;
            const conversationId =
                router.currentRoute.value.query.conversationId;

            const branchId = router.currentRoute.value.query.branchId;

            // Get branch
            const selectedBranch = store.state.branch.branches.find(
                (branch) => branch.id == branchId
            );

            if (router.currentRoute.value.path.includes('chat', 1)) {
                await store.dispatch('business/setBusinessID', businessId);
                await store.dispatch('business/setBusinessEndPoint');
                await store.dispatch('branch/setBranch', selectedBranch);

                const result = await store.dispatch(
                    'conversation/getOneConversation',
                    {
                        conversationId: conversationId,
                        isDownward: 0
                    }
                );

                if (result.conversations.length > 0) {
                    selectedConversation(result.conversations[0]);
                }
            }
        };

        const getIssueType = async () => {
            const result = await store.dispatch(
                'issueType/getIssueTypeByBusinessID',
                {
                    businessId: selectedBusinessId.value,
                    isHiddenIncluded: true
                }
            );

            if (result.issueTypes.length > 0) {
                result.issueTypes.forEach((element: any) => {
                    state.options.push({
                        label: element.name,
                        value: element.id
                    });
                    state.issues.push(element.id);
                    store.dispatch(
                        'conversation/setSelectedIssueTypeID',
                        state.issues
                    );
                });
                getConversationList();
            } else {
                state.issuesType = [];
            }
        };

        // Mounted
        onMounted(clearSelectedIssueType);
        onMounted(getIssueType);
        onMounted(getConversationsTransferList);
        onMounted(clearSelectedUserConversation);
        onMounted(getLocalForage);
        onMounted(checkIfUrlRedirect);

        return {
            tab: ref('chatting'),
            state,
            dense: ref(true),
            search,
            formatTime,
            formatDate,
            selectedConversation,
            socketStatus,
            accept,
            reject,
            clearSelectedUserConversation,
            ConversationTransferListType,
            resetNewForceConversationNotification,
            activeChat,
            selectedIssueTypeId,
            clearSelectedIssueType
        };
    }
});
</script>
